diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
new file mode 100644
index 000000000..8d860ad50
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
@@ -0,0 +1,380 @@
+package net.minecraft.core.block.piston;
+
+import java.util.ArrayList;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+public class PistonBaseBlock extends Block
+{
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public static final int MASK_POWERED = 0b0000_1000;
+
+    public static final int EVENT_EXTEND = 0;
+    public static final int EVENT_RETRACT = 1;
+
+    private final int maxPushedBlocks;
+
+    public PistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks)
+    {
+        super(key, namespaceId, id, Material.piston);
+        this.maxPushedBlocks = maxPushedBlocks;
+        withHardness(0.5F);
+    }
+
+    @Override
+	public boolean isSolidRender()
+    {
+        return false;
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
+        world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
+        if(!world.isClientSide)
+        {
+            checkIfExtend(world, x, y, z);
+        }
+    }
+
+    @Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        checkIfExtend(world, x, y, z);
+    }
+
+    @Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
+        {
+            checkIfExtend(world, x, y, z);
+        }
+    }
+
+    private void checkIfExtend(World world, int x, int y, int z)
+    {
+        int data = world.getBlockMetadata(x, y, z);
+        Direction direction = getDirection(data);
+        boolean hasNeighborSignal = getNeighborSignal(world, x, y, z, direction);
+        if(data == MASK_DIRECTION)
+        {
+            return;
+        }
+        if(hasNeighborSignal && !isPowered(data))
+        {
+            if(canPushLine(world, x, y, z, direction, maxPushedBlocks))
+            {
+                world.setBlockMetadata(x, y, z, direction.getId() | MASK_POWERED);
+                world.triggerEvent(x, y, z, EVENT_EXTEND, direction.getId());
+            }
+        }
+        else if(!hasNeighborSignal && isPowered(data))
+        {
+            world.setBlockMetadata(x, y, z, direction.getId());
+            world.triggerEvent(x, y, z, EVENT_RETRACT, direction.getId());
+        }
+    }
+
+    private boolean getNeighborSignal(World world, int x, int y, int z, Direction direction) {
+        if(direction != Direction.DOWN && world.getSignal(x, y - 1, z, Side.BOTTOM)) {
+            return true;
+        }
+        if(direction != Direction.UP && world.getSignal(x, y + 1, z, Side.TOP)) {
+            return true;
+        }
+        if(direction != Direction.NORTH && world.getSignal(x, y, z - 1, Side.NORTH)) {
+            return true;
+        }
+        if(direction != Direction.SOUTH && world.getSignal(x, y, z + 1, Side.SOUTH)) {
+            return true;
+        }
+        if(direction != Direction.EAST && world.getSignal(x + 1, y, z, Side.EAST)) {
+            return true;
+        }
+        if(direction != Direction.WEST && world.getSignal(x - 1, y, z, Side.WEST)) {
+            return true;
+        }
+        if(world.getSignal(x, y, z, Side.BOTTOM)) {
+            return true;
+        }
+        // QC
+        if(direction != Direction.UP && world.getSignal(x, y + 2, z, Side.TOP)) {
+            return true;
+        }
+        if(world.getSignal(x, y + 1, z - 1, Side.NORTH)) {
+            return true;
+        }
+        if(world.getSignal(x, y + 1, z + 1, Side.SOUTH)) {
+            return true;
+        }
+        if(world.getSignal(x - 1, y + 1, z, Side.WEST)) {
+            return true;
+        }
+        return world.getSignal(x + 1, y + 1, z, Side.EAST);
+    }
+
+    @Override
+    public void triggerEvent(World world, int x, int y, int z, int index, int data)
+    {
+        Direction direction = getDirection(data);
+        if (direction == Direction.NONE) direction = Direction.DOWN; // Probably going to end with a downwards facing bedrock breaker
+        if(index == EVENT_EXTEND)
+        {
+            extendEvent(world, x, y, z, data, direction);
+        }
+        else if(index == EVENT_RETRACT)
+        {
+            retractEvent(world, x, y, z, data, direction);
+        }
+    }
+
+    public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
+        if(tryExtend(world, x, y, z, direction, maxPushedBlocks))
+        {
+            world.setBlockMetadataWithNotify(x, y, z, direction.getId() | MASK_POWERED);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
+        }
+    }
+
+    public void retractEvent(World world, int x, int y, int z, int data, Direction direction) {
+        BlockEntity blockEntity = world.getBlockEntity(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ());
+        if((blockEntity instanceof MovingPistonBlockEntity))
+        {
+            MovingPistonBlockEntity moving = ((MovingPistonBlockEntity) blockEntity);
+            if (!moving.isExtending()) {
+                ((MovingPistonBlockEntity)blockEntity).finalTick();
+            } else {
+                world.setBlock(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
+            }
+        }
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, direction.getId());
+        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(id, direction.getId(), null, direction, false, true));
+        world.setBlockWithNotify(x + direction.getOffsetX(), y + direction.getOffsetY(), z + direction.getOffsetZ(), 0);
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)x + 0.5D, (double)y + 0.5D, (double)z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    {
+        int data = world.getBlockMetadata(x, y, z);
+        if(isPowered(data))
+        {
+            switch(getDirection(data))
+            {
+                case DOWN:
+                setBlockBounds(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
+                break;
+                case UP:
+                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
+                break;
+                case NORTH:
+                setBlockBounds(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
+                break;
+                case SOUTH:
+                setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
+                break;
+                case WEST:
+                setBlockBounds(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                break;
+                case EAST:
+                setBlockBounds(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
+                break;
+            }
+        } else
+        {
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+        }
+    }
+    @Override
+    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbs)
+    {
+        setBlockBoundsBasedOnState(world, x, y, z);
+        super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbs);
+    }
+
+    @Override
+	public boolean isCubeShaped()
+    {
+        return false;
+    }
+
+    public static Direction getDirection(int data)
+    {
+        return Direction.getDirectionById(data & MASK_DIRECTION);
+    }
+
+    public static boolean isPowered(int data)
+    {
+        return (data & MASK_POWERED) != 0;
+    }
+    
+    protected boolean isPushable(int id, World world, int x, int y, int z, boolean canDestroy)
+    {
+        Block block = Block.getBlock(id);
+        if (block == null) return false;
+        int pushReaction = block.getPistonPushReaction(world, x, y, z);
+        if (block.hasTag(BlockTags.PISTON_CRUSHING) ||
+            block.getImmovable() ||
+            pushReaction == Material.PISTON_CANT_PUSH ||
+            (!canDestroy && pushReaction == Material.PISTON_DESTROY_ON_PUSH) ||
+            block.getHardness() == -1F) {
+            return false;
+        }
+        return true;
+    }
+
+    @Override
+    public int getPistonPushReaction(World world, int x, int y, int z) {
+        if (isPowered(world.getBlockMetadata(x, y, z))) {
+            return Material.PISTON_CANT_PUSH;
+        }
+        return super.getPistonPushReaction(world, x, y, z);
+    }
+
+    protected boolean canPushLine(World world, int x, int y, int z, Direction direction, int maxPushedBlocks)
+    {
+        int xo = x + direction.getOffsetX();
+        int yo = y + direction.getOffsetY();
+        int zo = z + direction.getOffsetZ();
+        int blocks = 0;
+        while (true) {
+            if (blocks >= maxPushedBlocks + 1) {
+                break;
+            }
+            if (yo < 0 || yo >= world.getHeightBlocks()) {
+                return false;
+            }
+            int id = world.getBlockId(xo, yo, zo);
+            if (id == 0) {
+                break;
+            }
+            if (!isPushable(id, world, xo, yo, zo, true)) {
+                if (blocks == 1 && BlockTags.PISTON_CRUSHING.appliesTo(Block.getBlock(id)) && tryCrush(world, x, y, z, direction)) {
+                    break;
+                }
+                return false;
+            }
+            if (Block.blocksList[id].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+                break;
+            }
+            if (blocks == maxPushedBlocks) {
+                return false;
+            }
+            xo += direction.getOffsetX();
+            yo += direction.getOffsetY();
+            zo += direction.getOffsetZ();
+            blocks++;
+        }
+        return true;
+    }
+
+    public boolean tryCrush(World world, int x, int y, int z, Direction direction) {
+        int x2 = x + direction.getOffsetX();
+        int y2 = y + direction.getOffsetY();
+        int z2 = z + direction.getOffsetZ();
+        Block block = world.getBlock(x2, y2, z2);
+        if (block == null) return true;
+        world.playSoundEffect(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
+        block.dropBlockWithCause(world, EnumDropCause.SILK_TOUCH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
+        world.setBlockWithNotify(x2, y2, z2, 0);
+        return true;
+    }
+
+    protected boolean tryExtend(World world, int x, int y, int z, Direction direction, int maxPushedBlocks)
+    {
+        int data = world.getBlockMetadata(x, y, z);
+        int xo = x + direction.getOffsetX();
+        int yo = y + direction.getOffsetY();
+        int zo = z + direction.getOffsetZ();
+        int blocks = 0;
+        while (true) {
+            if (blocks >= maxPushedBlocks + 1) {
+                break;
+            }
+            if (yo < 0 || yo >= world.getHeightBlocks()) {
+                return false;
+            }
+            int blockId = world.getBlockId(xo, yo, zo);
+            if (blockId == 0) {
+                break;
+            }
+            if (!isPushable(blockId, world, xo, yo, zo, true)) {
+                return false;
+            }
+            if (Block.blocksList[blockId].getPistonPushReaction(world, xo, yo, zo) == Material.PISTON_DESTROY_ON_PUSH) {
+                Block.blocksList[blockId].dropBlockWithCause(world, EnumDropCause.WORLD, xo, yo, zo, world.getBlockMetadata(xo, yo, zo), null, null);
+                world.setBlockWithNotify(xo, yo, zo, 0);
+                break;
+            }
+            if (blocks == maxPushedBlocks) {
+                return false;
+            }
+            xo += direction.getOffsetX();
+            yo += direction.getOffsetY();
+            zo += direction.getOffsetZ();
+            blocks++;
+        }
+        while (xo != x || yo != y || zo != z) {
+            int px = xo - direction.getOffsetX();
+            int py = yo - direction.getOffsetY();
+            int pz = zo - direction.getOffsetZ();
+            int pushId = world.getBlockId(px, py, pz);
+            int pushMeta = world.getBlockMetadata(px, py, pz);
+            BlockEntity pushEntity = world.getBlockEntity(px, py, pz);
+            if(pushId == id && px == x && py == y && pz == z)
+            {
+                createPistonHeadAt(world, xo, yo, zo, data, direction);
+            } else if (pushId == Blocks.PISTON_MOVING.id)
+            {
+                BlockEntity old = world.getBlockEntity(px, py, pz);
+                if (old instanceof MovingPistonBlockEntity) {
+                    MovingPistonBlockEntity moving = (MovingPistonBlockEntity) old;
+                    if (!moving.isSourcePiston()) {
+                        pushId = moving.getMovedId();
+                        pushMeta = moving.getMovedData();
+                        pushEntity = moving.getMovedEntity();
+                    }
+                }
+                world.removeBlockTileEntity(px, py, pz);
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
+                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+            } else
+            {
+                world.removeBlockTileEntity(px, py, pz);
+                world.setBlockAndMetadata(xo, yo, zo, Blocks.PISTON_MOVING.id, pushMeta);
+                world.replaceBlockTileEntity(xo, yo, zo, MovingPistonBlock.createTileEntity(pushId, pushMeta, pushEntity, direction, true, false));
+            }
+            xo = px;
+            yo = py;
+            zo = pz;
+        }
+
+        return true;
+    }
+
+    public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_NORMAL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_NORMAL, direction.getId()), null, direction, true, false));
+    }
+    
+    @Override
+    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    	return MASK_DIRECTION; // For all faces piston blocks ig
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
index 027e1d67d..11cb1fdfe 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonHeadBlock.java
@@ -8,7 +8,8 @@ import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.sound.BlockSound;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
@@ -16,33 +17,40 @@ import net.minecraft.core.world.WorldSource;
 
 public class PistonHeadBlock extends Block
 {
-
-    public PistonHeadBlock(String key, String namespaceId, int id)
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public static final int MASK_TYPE = 0b1111_1000;
+    public static final int TYPE_NORMAL = 0;
+    public static final int TYPE_STICKY = 1;
+    public static final int TYPE_STEEL = 2;
+
+    private final double headThickness;
+    public PistonHeadBlock(String key, String namespaceId, int id, double headThickness)
     {
         super(key, namespaceId, id, Material.piston);
         withHardness(0.5F);
+        this.headThickness = headThickness;
     }
 
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         super.onBlockRemoved(world, x, y, z, data);
-        int direction = getDirectionFromMeta(data);
-        if(direction >= 6) {
+        Direction direction = getDirectionFromMeta(data);
+        if(direction == Direction.NONE) {
         	return;
         }
-        int orientation = PistonDirections.directionMap[direction];
-        x += PistonDirections.xOffset[orientation];
-        y += PistonDirections.yOffset[orientation];
-        z += PistonDirections.zOffset[orientation];
-        int k1 = world.getBlockId(x, y, z);
-        if(k1 == Blocks.PISTON_BASE.id || k1 == Blocks.PISTON_BASE_STICKY.id)
+        Direction orientation = direction.getOpposite();
+        int x2 = x + orientation.getOffsetX();
+        int y2 = y + orientation.getOffsetY();
+        int z2 = z + orientation.getOffsetZ();
+        Block block = world.getBlock(x2, y2, z2);
+        if(block instanceof PistonBaseBlock)
         {
-            int i1 = world.getBlockMetadata(x, y, z);
-            if(BasePistonBlock.isPowered(i1))
+            int data2 = world.getBlockMetadata(x2, y2, z2);
+            if(PistonBaseBlock.isPowered(data2))
             {
-                Block.blocksList[k1].dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x, y, z, i1, null, null);
-                world.setBlockWithNotify(x, y, z, 0);
+                block.dropBlockWithCause(world, EnumDropCause.PROPER_TOOL, x2, y2, z2, data2, null, null);
+                world.setBlockWithNotify(x2, y2, z2, 0);
             }
         }
     }
@@ -77,45 +85,45 @@ public class PistonHeadBlock extends Block
         int l = world.getBlockMetadata(x, y, z);
         switch(getDirectionFromMeta(l))
         {
-        case 0: // '\0'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.25F, 1.0F);
+            case DOWN: // '\0'
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.375F, 0.25F, 0.375F, 0.625F, 1.25F, 0.625F);
+            setBlockBounds(0.375F, headThickness, 0.375F, 0.625F, 1 + headThickness, 0.625F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
 
-        case 1: // '\001'
-            setBlockBounds(0.0F, 0.75F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case UP: // '\001'
+            setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.375F, -0.25F, 0.375F, 0.625F, 0.75F, 0.625F);
+            setBlockBounds(0.375F, -headThickness, 0.375F, 0.625F, 1 - headThickness, 0.625F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
 
-        case 2: // '\002'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.25F);
+            case NORTH: // '\002'
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.25F, 0.375F, 0.25F, 0.75F, 0.625F, 1.25F);
+            setBlockBounds(headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 + headThickness);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
 
-        case 3: // '\003'
-            setBlockBounds(0.0F, 0.0F, 0.75F, 1.0F, 1.0F, 1.0F);
+            case SOUTH: // '\003'
+            setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.25F, 0.375F, -0.25F, 0.75F, 0.625F, 0.75F);
+            setBlockBounds(headThickness, 0.375F, -headThickness, 1 - headThickness, 0.625F, 1 - headThickness);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
 
-        case 4: // '\004'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 0.25F, 1.0F, 1.0F);
+            case WEST: // '\004'
+            setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(0.25F, 0.375F, 0.25F, 1.25F, 0.625F, 0.75F);
+            setBlockBounds(headThickness, 0.375F, headThickness, 1 + headThickness, 0.625F, 1 - headThickness);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
 
-        case 5: // '\005'
-            setBlockBounds(0.75F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case EAST: // '\005'
+            setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
-            setBlockBounds(-0.25F, 0.375F, 0.25F, 0.75F, 0.625F, 0.75F);
+            setBlockBounds(-headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 - headThickness);
             super.getCollidingBoundingBoxes(world, x, y, z, aabb, aabbList);
             break;
         }
@@ -128,28 +136,28 @@ public class PistonHeadBlock extends Block
         int l = world.getBlockMetadata(x, y, z);
         switch(getDirectionFromMeta(l))
         {
-        case 0: // '\0'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.25F, 1.0F);
+            case DOWN: // '\0'
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
             break;
 
-        case 1: // '\001'
-            setBlockBounds(0.0F, 0.75F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case UP: // '\001'
+            setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
             break;
 
-        case 2: // '\002'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.25F);
+            case NORTH: // '\002'
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
             break;
 
-        case 3: // '\003'
-            setBlockBounds(0.0F, 0.0F, 0.75F, 1.0F, 1.0F, 1.0F);
+            case SOUTH: // '\003'
+            setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
             break;
 
-        case 4: // '\004'
-            setBlockBounds(0.0F, 0.0F, 0.0F, 0.25F, 1.0F, 1.0F);
+            case WEST: // '\004'
+            setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
             break;
 
-        case 5: // '\005'
-            setBlockBounds(0.75F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case EAST: // '\005'
+            setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
             break;
         }
     }
@@ -157,23 +165,29 @@ public class PistonHeadBlock extends Block
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        int direction = getDirectionFromMeta(world.getBlockMetadata(x, y, z));
-        if(direction >= 6) {
+        Direction direction = getDirectionFromMeta(world.getBlockMetadata(x, y, z));
+        if(direction == Direction.NONE) {
         	return;
         }
-        int id = world.getBlockId(x - PistonDirections.xOffset[direction], y - PistonDirections.yOffset[direction], z - PistonDirections.zOffset[direction]);
-        if(id != Blocks.PISTON_BASE.id && id != Blocks.PISTON_BASE_STICKY.id)
-        {
+        Block block = world.getBlock(x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ());
+        if (block instanceof PistonBaseBlock) {
+            block.onNeighborBlockChange(world, x - direction.getOffsetX(), y - direction.getOffsetY(), z - direction.getOffsetZ(), blockId);
+        } else {
             world.setBlockWithNotify(x, y, z, 0);
-        } else
-        {
-            Block.blocksList[id].onNeighborBlockChange(world, x - PistonDirections.xOffset[direction], y - PistonDirections.yOffset[direction], z - PistonDirections.zOffset[direction], blockId);
         }
     }
 
-    public static int getDirectionFromMeta(int meta)
+    public static Direction getDirectionFromMeta(int meta)
     {
-        return meta & 0b111;
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
+    }
+
+    public static int getPistonType(int data) {
+        return ((data & 0xFF) & MASK_TYPE) >> 3;
+    }
+
+    public static int setPistonType(int type, int data) {
+        return ((data & ~MASK_TYPE) | (type << 3)) & 0xFF;
     }
 
     @Override
@@ -181,13 +195,13 @@ public class PistonHeadBlock extends Block
     {
         if (dropCause == EnumDropCause.PICK_BLOCK)
         {
-            if((meta & 0b1000) != 0)
-            {
-                return new ItemStack[] { new ItemStack(Blocks.PISTON_BASE_STICKY) };
-            }
-            else
-            {
-                return new ItemStack[] { new ItemStack(Blocks.PISTON_BASE) };
+            switch (getPistonType(meta)) {
+                case TYPE_NORMAL:
+                    return new ItemStack[] { new ItemStack(Blocks.PISTON_BASE) };
+                case TYPE_STICKY:
+                    return new ItemStack[] { new ItemStack(Blocks.PISTON_BASE_STICKY) };
+                case TYPE_STEEL:
+                    return new ItemStack[] { new ItemStack(Blocks.PISTON_BASE_STEEL) };
             }
         }
 
diff --git a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
new file mode 100644
index 000000000..ebbf01eeb
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
@@ -0,0 +1,74 @@
+package net.minecraft.core.block.piston;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class SteelPistonBaseBlock extends PistonBaseBlock{
+    public static final double HEAD_THICKNESS_STEEL = 6/16d;
+
+    public SteelPistonBaseBlock(String key, String namespaceId, int id, int maxPushedBlocks) {
+        super(key, namespaceId, id, maxPushedBlocks);
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    {
+        int data = world.getBlockMetadata(x, y, z);
+        if(isPowered(data))
+        {
+            switch(getDirection(data))
+            {
+                case DOWN:
+                    setBlockBounds(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
+                    break;
+                case UP:
+                    setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
+                    break;
+                case NORTH:
+                    setBlockBounds(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
+                    break;
+                case SOUTH:
+                    setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
+                    break;
+                case WEST:
+                    setBlockBounds(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    break;
+                case EAST:
+                    setBlockBounds(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
+                    break;
+            }
+        } else
+        {
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+        }
+    }
+
+    @Override
+    public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
+        List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
+        for (Entity entity : entityList){
+            if (entity == null || entity.noPhysics) continue;
+            final double speed = 2;
+            entity.xd += speed * direction.getOffsetX();
+            entity.yd += speed * direction.getOffsetY();
+            entity.zd += speed * direction.getOffsetZ();
+            entity.fallDistance = 0;
+            entity.pushTime = 1f;
+        }
+        super.extendEvent(world, x, y, z, data, direction);
+    }
+
+    @Override
+    public void createPistonHeadAt(World world, int x, int y, int z, int data, Direction direction) {
+        world.setBlockAndMetadata(x, y, z, Blocks.PISTON_MOVING.id,  PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STEEL, direction.getId()));
+        world.replaceBlockTileEntity(x, y, z, MovingPistonBlock.createTileEntity(Blocks.PISTON_HEAD_STEEL.id, PistonHeadBlock.setPistonType(PistonHeadBlock.TYPE_STEEL, direction.getId()), null, direction, true, false));
+    }
+
+}
